defmodule Reactivity.Mixfile do
  use Mix.Project

  def project do
    [app: :reactivity,
     version: "0.1.0",
     elixir: "~> 1.4",
      build_embedded: Mix.env == :prod,
      start_permanent: Mix.env == :prod,
      description: description(),
      package: package(),
      deps: deps(),
      name: "Reactive Elixir",
      source_url: "https://github.com/m1dnight/reactive-elixir"]
  end

  # Configuration for the OTP application
  #
  # Type "mix help compile.app" for more information
  def application do
    # Specify extra applications you'll use from Erlang/Elixir
    [extra_applications: [:logger]]
  end

  # Dependencies can be Hex packages:
  #
  #   {:my_dep, "~> 0.3.0"}
  #
  # Or git/path repositories:
  #
  #   {:my_dep, git: "https://github.com/elixir-lang/my_dep.git", tag: "0.1.0"}
  #
  # Type "mix help deps" for more examples and options
  defp deps do
    [{:ex_doc, ">= 0.0.0", only: :dev}]
  end

  defp description do
    """
    A reactive programming library for Elixir. The purpose of this library is to experiment in an academic context.
    """
  end
  
  defp package do
    # These are the default files included in the package
    [
      name: :reactivity,
      files: ["lib", "mix.exs", "README*", "LICENSE*"],
      maintainers: ["Christophe De Troyer"],
      licenses: ["GPL3"],
      links: %{"GitHub" => "https://github.com/m1dnight/reactive-elixir"}
    ]
  end
end
